<?

class YouTube_Channel_List_Admin extends YouTube_Channel_List {
	/**
	 * Error messages to diplay
	 *
	 * @var array
	 */
	private $_messages = array();
	
	
	/**
	 * Class constructor
	 *
	 */
	public function __construct() {
		$this->_plugin_dir   = DIRECTORY_SEPARATOR . str_replace(basename(__FILE__), null, plugin_basename(__FILE__));
		$this->_settings_url = 'options-general.php?page=' . plugin_basename(__FILE__);;
		
		$allowed_options = array(
			
		);
		
		// set  options
		if(array_key_exists('option_name', $_GET) && array_key_exists('option_value', $_GET)
			&& in_array($_GET['option_name'], $allowed_options)) {
			update_option($_GET['option_name'], $_GET['option_value']);
			
			header("Location: " . $this->_settings_url);
			die();	

		} else {
			// register installer function
			register_activation_hook(YCL_LOADER, array(&$this, 'activateYouTubeChannelList'));
			

			
			// add plugin "Settings" action on plugin list
			add_action('plugin_action_links_' . plugin_basename(YCL_LOADER), array(&$this, 'add_plugin_actions'));
			
			// add links for plugin help, donations,...
			add_filter('plugin_row_meta', array(&$this, 'add_plugin_links'), 10, 2);
			
			// push options page link, when generating admin menu
			//add_action('admin_menu', array(&$this, 'adminMenu'));
	
			// check if post_id is "-1", meaning we're uploading watermark image
			//if(!(array_key_exists('post_id', $_REQUEST) && $_REQUEST['post_id'] == -1)) {
				// add filter for watermarking images
				//add_filter('wp_generate_attachment_metadata', array(&$this, 'applyWatermark'));
			//}
		}
	}
	
	/**
	 * Add "Settings" action on installed plugin list
	 */
	public function add_plugin_actions($links) {
		array_unshift($links, '<a href="options-general.php?page=' . plugin_basename(__FILE__) . '">' . __('Settings') . '</a>');
		
		return $links;
	}
	
	/**
	 * Add links on installed plugin list
	 */
	public function add_plugin_links($links, $file) {
		if($file == plugin_basename(YCL_LOADER)) {
			$links[] = '<a href="http://MyWebsiteAdvisor.com">Premium Plugins</a>';
		}
		
		return $links;
	}
	
	/**
	 * Add menu entry for Transparent Watermark settings and attach style and script include methods
	 */
	public function adminMenu() {		
		// add option in admin menu, for setting details on watermarking
		//$plugin_page = add_options_page('YouTube Channel List', 'YouTube Channel List', 8, __FILE__, array(&$this, 'optionsPage'));

		//add_action('admin_print_styles-' . $plugin_page,     array(&$this, 'installStyles'));
	
		// also add JS to media upload popup
		//add_action('admin_print_scripts-media-upload-popup', array(&$this, 'installScripts'));
	}
	
	/**
	 * Include styles used by Plugin
	 */
	public function installStyles() {
		//wp_enqueue_style('youtube_channel_list', WP_PLUGIN_URL . $this->_plugin_dir . 'style.css');
	}
	



	
	/**
	 * Display options page
	 */
	public function optionsPage() {
		// if user clicked "Save Changes" save them
		if(isset($_POST['Submit'])) {
			foreach($this->_options as $option => $value) {
				if(array_key_exists($option, $_POST)) {
					update_option($option, $_POST[$option]);
				} else {
					update_option($option, $value);
				}
			}

			
			update_option('wp_dev_stats_html', '');

			$this->_messages['updated'][] = 'Options updated!';
		}
		
	
		foreach($this->_messages as $namespace => $messages) {
			foreach($messages as $message) {
?>
<div class="<?php echo $namespace; ?>">
	<p>
		<strong><?php echo $message; ?></strong>
	</p>
</div>
<?php
			}
		}
?>
<script type="text/javascript">var wpurl = "<?php bloginfo('wpurl'); ?>";</script>
<div class="wrap">
	<div id="icon-options-general" class="icon32"><br /></div>
	<h2>YouTube Channel List</h2>
		<form method="post" action="">

			<a name="wp_dev_name"></a>
			<div id="wp_dev_name" class="wp_dev_name">
				<h3>YouTube Channel Name</h3>
				<p>Please enter your YouTube Channel Name</p>

				<table class="form-table">
					
					<? $channel_name = $this->get_option('channel_name'); ?>

					<tr valign="top">
						<th scope="row">Channel Name</th>
						<td class="wr_width">
							<fieldset class="wr_width">
							<legend class="screen-reader-text"><span>Channel Name</span></legend>

								<input type="text" name="wp_dev_name" value="<? echo $channel_name; ?>" ><br>
								Ex: MyWebsiteAdvisor would display the top videos from the YouTube channel for MyWebsiteAdvisor.com

							</fieldset>
						</td>
						
					</tr>
					
				</table>
			</div>

			<a name="plugin_limit"></a>
			<div id="plugin_limit" class="plugin_limit">
				<h3>Video Display Limit</h3>
				<p>Choose how many videos to display.</p>

				<table class="form-table">
					<? $youtube_channel_limit = $this->get_option('youtube_channel_limit'); ?>
					

					<tr valign="top">
						<th scope="row">Video Display Limit</th>
						<td class="wr_width">
							<fieldset class="wr_width">
							<legend class="screen-reader-text"><span>Video Display Limit</span></legend>

								<input size="5" type="text" name="youtube_channel_limit" value="<? echo $youtube_channel_limit ?>" ><br>
								Ex: 5 would show the top 5 plugins.
								
								
								
								
							</fieldset>
						</td>
						
					</tr>
					
				</table>
			</div>


			<a name="link_target"></a>
			<div id="link_target" class="link_target">
				<h3>Link Target</h3>
				<p>Choose a Link Target.</p>

				<table class="form-table">
					<? $link_target = $this->get_option('link_target'); ?>
					

					<tr valign="top">
						<th scope="row">Link Target</th>
						<td class="wr_width">
							<fieldset class="wr_width">
							<legend class="screen-reader-text"><span>Link Target</span></legend>

								<select name='link_target'>
									<option value='_blank' <? if($link_target=="_blank"){ echo "selected='selected'";} ?> >_blank</option>
									<option value='_self' <? if($link_target=="_self"){ echo "selected='selected'";} ?>>_self</option>
								</select><br>

								
								Example: Use '_blank' if you wish your links to open a new window or tab. Use _self if you want the links to open in the current browser tab.
								
								
							</fieldset>
						</td>
						
					</tr>
					
				</table>
			</div>


			<p class="submit">
				<input type="submit" name="Submit" class="button-primary" value="Save Changes" />
			</p>

		</form>
</div>

<hr>


<?php

                                                   
              require_once("youtube_scraper.class.php");

		$yt2 = new YouTube_Scraper();
		$yt2->channel_name = $this->get_option('channel_name');
		//$yt2->youtube_channel_limit = $this->get_option('youtube_channel_limit');
		//$yt2->link_target = $this->get_option('link_target');
                                                    
		$yt_dev_info = $yt2->get_channel_info();
		//print_r($yt_dev_info);
            
               $i = 0;
                                                    
              echo "<ul>";                                      
            foreach($yt_dev_info->entry as $vid){
              
                if($i < $this->get_option('youtube_channel_limit')){                                  
                                                    
                   $link = $vid->link->attributes()->href;                                     
                   $title = $vid->title;
                   $target = $this->get_option('link_target');
                                                        
                    echo "<li><a href='$link' target='$target'>$title</a></li>";
                                                    
                     $i++;                               
                }                  
              
            }
             echo "</ul>";  
             
                   
		                               

	}
}

$youtube_channel_list_admin = new YouTube_Channel_List_Admin();
?>